EDIT - bug #9578

Multiselect for input of distribution editor creates duplicates

04/02/2021 01:00 AM - Andreas Miller

Status: Closed Start date:

Priority: New Due date:

Assignee: Andreas Muller % Done: 100%
Category: cdmlib Estimated time: 0:00 hour
Target version: Release 5.22

Severity: normal Found in Version:

Description

if 1 record select only this record is returned

if 2 records are selected 1 record is duplicated

if 3 records are selected 1 record appears 3x onother is duplicated

etc.

Related issues:

Related to EDIT - feature request #8889: Remaining issues for distribution ed... In Progress
Related to EDIT - bug #9581: Strange focus behavior in taxon navigator after ... New

Associated revisions

Revision ba87a40e - 04/02/2021 01:08 AM - Andreas Muller

fix #9578 remove duplicates from distributionDto service

Revision c60e36b3 - 04/02/2021 01:18 AM - Andreas Miiller

fix #9578 remove duplicates from distributionDto service (complete test)

Revision e5083306 - 04/14/2021 09:52 AM - Katja Luther

ref #9578: avoid duplicates for parent and child selection

Revision bf69d17d - 04/14/2021 06:18 PM - Andreas Miiller

ref #9578 , ref #8889 fix behavior of TaxonNodeDaoHibernatelmpl.listChildrenOf() with recursive=true and comparator

e current implementation also returns the parent which is semantically not correct and differs from implementation without comparator

Revision 273d91ee - 04/14/2021 06:18 PM - Andreas Miiller

ref #9578 , ref #8889 switch on sorting for recursive=false in TaxonNodeServicelmpl.loadChildNodesOfTaxonNode()

Revision 78be9787 - 04/14/2021 06:18 PM - Andreas Miiller

ref #9578 , ref #8889 add parentNode in getTaxonDistributionDTO() instead and handle openChildren correctly there

Revision ab18e527 - 04/14/2021 06:57 PM - Andreas Miiller
ref #9578 , ref #8889 fix duplicate handling in getTaxonDistributionDTO

History

#1 - 04/02/2021 01:08 AM - Andreas Miiller
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|ba87a40e9a4066100dff6e13c5aebb2b1782e4b6.

#2 - 04/13/2021 12:04 PM - Andreas Miiller

- Assignee changed from Andreas Miiller to Katja Luther
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/ba87a40e9a4066100dff6e13c5aebb2b1782e4b6

This works now for taxon nodes not sharing duplicates (e.g. for sibblings). It still shows duplicates if e.g. one selects a parent and some of it's
children. The later should either not be possible (I don't know if this is easy to implement in the navigator) or it should be handled such that the
algorithm should recognize the child duplicates and remove them.
Can you please review my changes and either implement the open issue or create a new ticket?
#3 - 04/14/2021 09:48 AM - Katja Luther
Andreas Muller wrote:
This works now for taxon nodes not sharing duplicates (e.g. for sibblings). It still shows duplicates if e.g. one selects a parent and some of it's
children. The later should either not be possible (I don't know if this is easy to implement in the navigator) or it should be handled such that the
algorithm should recognize the child duplicates and remove them.
Can you please review my changes and either implement the open issue or create a new ticket?
Your changes work fine. To forbid the selection of a parent and some of his children is a little bit more difficult, | adapt the algorithm to avoid

duplicates of children as a first step, but maybe this is a little bit confusing because the user selected the parent and for example 4 of 6 children but
gets all 6 children.

#4 - 04/14/2021 09:52 AM - Katja Luther

- Assignee changed from Katja Luther to Andreas Mdiller

please review my changes.

#5 - 04/14/2021 09:53 AM - Andreas Miiller
- Assignee changed from Andreas Muiller to Katja Luther
Katja Luther wrote:
Andreas Muller wrote:
This works now for taxon nodes not sharing duplicates (e.g. for sibblings). It still shows duplicates if e.g. one selects a parent and some of
it's children. The later should either not be possible (I don't know if this is easy to implement in the navigator) or it should be handled such
that the algorithm should recognize the child duplicates and remove them.
Can you please review my changes and either implement the open issue or create a new ticket?
Your changes work fine. To forbid the selection of a parent and some of his children is a little bit more difficult, | adapt the algorithm to avoid

duplicates of children as a first step, but maybe this is a little bit confusing because the user selected the parent and for example 4 of 6 children
but gets all 6 children.

Thats true but not so relevant | think. Selecting parent & children does not make sense anyway so | don't expect many users to do this. If they do it
however, they will probably understand why the result is as it is.

#6 - 04/14/2021 12:16 PM - Andreas Miiller
- Status changed from Resolved to Feedback
Katja Luther wrote:
please review my changes.
Have you tested this? It does not work. And it can't work as parent seem to be handled elsewhere. So the selected children are also added as parents

(because they are selected).
This maybe happens on TaxEditor side or elsewhere but for sure not in getTaxonDistributionDTO()

#7 - 04/14/2021 01:57 PM - Katja Luther
Andreas Miller wrote:

Katja Luther wrote:

please review my changes.
Have you tested this? It does not work. And it can't work as parent seem to be handled elsewhere. So the selected children are also added as

parents (because they are selected).
This maybe happens on TaxEditor side or elsewhere but for sure not in getTaxonDistributionDTO()

Yes, | tested it locally. | will test again with nightly.
#8 - 04/14/2021 02:04 PM - Andreas Miiller
Katja Luther wrote:
Andreas Miiller wrote:
Katja Luther wrote:
please review my changes.

Have you tested this? It does not work. And it can't work as parent seem to be handled elsewhere. So the selected children are also added

as parents (because they are selected).
This maybe happens on TaxEditor side or elsewhere but for sure not in getTaxonDistributionDTO()

Yes, | tested it locally. | will test again with nightly.

Upps, maybe only a server restart is needed as this is cdmlib-side. However, | do not understand the handling of parents in the method. How are they
added to the final result?

#9 - 04/14/2021 02:22 PM - Katja Luther
Andreas Muller wrote:
Katja Luther wrote:
Andreas Miiller wrote:
Katja Luther wrote:
please review my changes.

Have you tested this? It does not work. And it can't work as parent seem to be handled elsewhere. So the selected children are also

added as parents (because they are selected).
This maybe happens on TaxEditor side or elsewhere but for sure not in getTaxonDistributionDTO()

Yes, | tested it locally. | will test again with nightly.

Upps, maybe only a server restart is needed as this is cdmlib-side. However, | do not understand the handling of parents in the method. How are
they added to the final result?

The criteria for getting the children is

crit.add( Restrictions.like ("treeIndex", node.treelIndex()+ "$") );

therefore also the node itself is found.

#10 - 04/14/2021 04:43 PM - Andreas Miiller
Katja Luther wrote:
The criteria for getting the children is

crit.add( Restrictions.like ("treeIndex", node.treelIndex()+ "%") );

therefore also the node itself is found.
Yes, but later there is

results.remove (node) ;
which removes the parent node. The correct behavior is tested in TaxonNodeDaoHibernatelmplTest.testListChildren(). If the result contains the
parent, too, we urgently need to fix the method or rename it because this is not the expected behavior for the given method name | guess.

#11 - 04/14/2021 04:50 PM - Katja Luther
Andreas Miller wrote:
Katja Luther wrote:
The criteria for getting the children is
crit.add( Restrictions.like ("treeIndex", node.treelIndex()+ "%") );

therefore also the node itself is found.

Yes, but later there is

results.remove (node) ;
which removes the parent node. The correct behavior is tested in TaxonNodeDaoHibernatelmplTest.testListChildren(). If the result contains the
parent, too, we urgently need to fix the method or rename it because this is not the expected behavior for the given method name | guess.
Sorry it is the method listChildrenOfRecursive, there the node is added to the result:
if (!previousResult.contains (node)) {

previousResult.add (node) ;

}

#12 - 04/14/2021 05:03 PM - Andreas Miiller

- Related to feature request #8889: Remaining issues for distribution editor - continue added
#13 - 04/14/2021 06:21 PM - Andreas Miiller
Katja Luther wrote:

Sorry it is the method listChildrenOfRecursive, there the node is added to the result:

if (!previousResult.contains (node)) {

previousResult.add (node) ;

}

Ok, this is obviously an error in the method with recursive=true and comparator != null as the method returns another collection size then calling it
without comparator. | fixed this and added a test.
As the parent is now missing | added it in getTaxonDistributionDTO() instead which IMO is the correct place for adding.

Can you please review? | havn't tested the result yet.

#14 - 04/14/2021 10:49 PM - Andreas Miiller

- Related to bug #9581: Strange focus behavior in taxon navigator after right mouse click added

#15 - 04/14/2021 10:51 PM - Andreas Miiller
- % Done changed from 50 to 80

| tested now and it seems to work as expected. Please also review.

#16 - 04/15/2021 08:37 AM - Katja Luther
- Status changed from Feedback to Closed

- Assignee changed from Katja Luther to Andreas Miiller

looks fine and works as expected

#17 - 04/15/2021 08:38 AM - Katja Luther
- % Done changed from 80 to 100
